import java.util.*;

class Omega{
    private static final long[] nextnum={2, 3, 4, 5, 7, 8, 9, 11, 13, 16, 17, 19, 23, 25, 27, 31, 32, 37, 41, 43, 47, 49, 53, 59, 61, 64, 67, 71, 73, 79, 81, 83, 89, 97, 101, 103, 107, 109, 113, 121, 125, 127, 128, 131, 137, 139, 149};
    private static long[] nextnumber;
    public static void main(String[] args){
	System.out.println("\\Omega(n)-Berechner");
	System.out.println("Copyright (C) 2006 Yves Radunz\n");
	if (args.length!=3){
	    showinfo();
	    return;
	}
	long n0=Integer.parseInt(args[0]),
	    n1=Integer.parseInt(args[1]),
	    n2=Integer.parseInt(args[2]);
	if (n0<0 || n2<n0 || n2>150 || n1>=n2-n0 || n1<1){
	    showinfo();
	    return;
	}
	nextnumber=new long[(int)(nextnum[nextnum.length-1]+1)];
	long j=0;
	nextnumber[0]=1;
	for (int i=0;i<nextnum.length;i++)
	    nextnumber[(int)(j=nextnumber[(int)j])]=nextnum[(int)i];
	nextnumber[nextnumber.length-1]=1000;
	for (int n=(int)n0;n<=(int)n2;n+=(int)n1){
	    System.out.print("n="+(n<100?(n<10?"00":"0"):"")+n+": ");
	    System.out.println("      Omega(n)="+omega(n));
	}
    }
    private static void showinfo(){
	System.out.println("Omega Start Step End");
	System.out.println(" Start - First n which is used to evaluate Omega(n)");
	System.out.println(" Step  - Every Step-th n is used to evaluate Omega(n)");
	System.out.println(" End   - Largest n which is used to evaluate Omega(n)");
	System.out.println(" End-Start+1 >= Step > 0 <= Start <= End <= 150");
    }
    private static long kgV(long[] werte){
	if (werte.length==0)
	    return 0;
	long tmp=werte[0];
	if (werte.length==1)
	    return tmp;
	for (int i=1;i<werte.length;i++)
	    tmp*=werte[i];
	return tmp;
    }
    private static long omega(long n){
	long[] part=new long[(int)n];
	long[] tmp;
	long maxkgV=0, j, kgv=0;
	String ausgabe="", ausgabe2="";
	if (n==0){
	    System.out.println("[]");
	    return 0;
	}
	Arrays.fill(part,1);
	while (!ausgabe.equals(arraytostring(part))){
	    ausgabe=arraytostring(part);
	    j=0;
	    for (int i=0;i<n;i++)
		if (part[i]!=0)
		    j++;
	    tmp=new long[(int)j];
	    for (int i=0;i<j;i++)
		tmp[i]=part[i];
	    kgv=kgV(tmp);
	    if (kgv>maxkgV && tmp[0]<=n){
		maxkgV=kgv;
		ausgabe2=arraytostring(tmp);
	    }
	    increment(part, n);
	}
	System.out.println(ausgabe2);
	return maxkgV;
    }
    private static String arraytostring(long[] werte){
	String tmp="[";
	long n=werte.length;
	for (int j=0;j<n;j++)
	    tmp+=werte[j]+(j<n-1?", ":"");
	return tmp+"]";
    }
    private static void increment(long[] werte, long gesamt){
	boolean keinTeiler;
	for (int i=werte.length-1;i>=0;i--){
	    if (i==0 || werte[i]<werte[i-1]){
		long s=0;
		for (int j=0;j<i;j++)
		    s+=werte[j];
		s+=nextnumber[(int)werte[i]];
		if (s<=gesamt){
		    werte[i]=nextnumber[(int)werte[i]];
		    i++;
		    if (i<gesamt){
			if (i<s)
			    for (int j=i;j<werte.length;j++)
				werte[j]=0;
			for (int j=i;j<gesamt-s+i;j++)
			    werte[j]=1;
		    }
		    keinTeiler=true;
		    for (int j=--i-1;j>=0;j--)
			keinTeiler&=(werte[j]%werte[i]!=0);
		    if (keinTeiler && (i<1 || werte[0]==gesamt || werte[i-1]!=werte[i]))
			return;
		    if (!keinTeiler)
			i++;
		}
	    }
	}
    }
}